SD_BUS_REPLY_METHOD_ERROR(3)

NAME
sd_bus_reply_method_error, sd_bus_reply_method_errorf, sd_bus_reply_method_errno, sd_bus_reply_method_errnof - Reply with an error to a method call

SYNOPSIS

#include <systemd/sd-bus.h>

int sd_bus_reply_method_error(sd_bus_message *call, const sd_bus_error *e);

int sd_bus_reply_method_errorf(sd_bus_message *call, const char *name, const char *format, ...);

int sd_bus_reply_method_errno(sd_bus_message *call, int error, const sd_bus_error *p);

int sd_bus_reply_method_errnof(sd_bus_message *call, int error, const char *format, ...);

DESCRIPTION

The sd_bus_reply_method_error() function sends an error reply to the call message. The error structure e specifies the error to send, and is used as described in sd_bus_message_new_error(3). If no reply is expected to call, this function returns success without sending reply.

The sd_bus_reply_method_errorf() is to sd_bus_reply_method_error() what sd_bus_message_new_method_errorf() is to sd_bus_message_new_method_error().

The sd_bus_reply_method_errno() is to sd_bus_reply_method_error() what sd_bus_message_new_method_errno() is to sd_bus_message_new_method_error().

The sd_bus_reply_method_errnof() is to sd_bus_reply_method_error() what sd_bus_message_new_method_errnof() is to sd_bus_message_new_method_error().

RETURN VALUE

These functions return 0 if the error reply was successfully sent or if none was expected, and a negative errno-style error code otherwise.

ERRORS

Returned errors may indicate the following problems:

-EINVAL
    The call message call is NULL.

    Message call is not a method call message.

    Message call is not attached to a bus.

    The error error parameter to sd_bus_reply_method_error is not set, see sd_bus_error_is_set(3).

-EPERM
    Message call has been sealed.

-ENOTCONN
    The bus to which message call is attached is not connected.

-ENOMEM
    Memory allocation failed.

In addition, any error message returned by sd_bus_send(1) may be returned.

NOTES

These APIs are implemented as a shared library, which can be compiled and linked to with the libsystemd pkg-config(1) file.

SEE ALSO

systemd(1), sd-bus(3), sd_bus_message_new_method_error(3)